unit UDomino;

interface


const MaxN = 15;
type
  TNum = 1..6;  //
  TIndex = 1..MaxN;
  TDomino = record
    a,b: TNum;
  end;
  TNabor = array[TIndex] of TDomino;
  TSet = set of TIndex;

  Domino = class
    private
    FresNabor: TNabor;    //    
    FMaxNabor: TNabor;    //    
    procedure solution(Res: TSet;  k: integer; var ResNabor: TNabor; var All: boolean);
    protected
    FMaxK: integer;    //    
    FSize: integer;    //    
    FDefN: TNabor; //  
    public
    constructor Create;
    procedure LangLinie;  // . 
    function AddSt (_a,_b: TNum): boolean; //   .
    property Size: integer read FSize;   // . 
    property MaxNabor: TNabor read FMaxNabor;
    property MaxSize: integer read FMaxK;
  end;


implementation

procedure swap (var D:TDomino);
var t: byte;
begin
t:=D.a;
D.a:=D.b;
D.b:=t;
end;

constructor Domino.Create;
begin
  FSize:=0; //    0 
end;

procedure Domino.solution(Res: TSet;  k: integer; var ResNabor: TNabor; var All: boolean);
var i: integer;

begin
if k>FSize then        // 
  begin
    FMaxNabor:=ResNabor;  //   , 
    FMaxK:=k;             //   All:=true
    All:=true;
  end
  else
  begin
    i:=1;
    //,   ,  
    while (i<=FSize) and ((i in res) or
    not ((FDefN[i].a=resNabor[k-1].b) or (FDefN[i].b=resNabor[k-1].b)))
    do inc(i);
    // ,      -    .
    if i>FSize then
    begin
      if k>FMaxK then
      begin
        FMaxK:=k;   //    ,   
        FMaxnabor:=resnabor;
      end //   .
    end else
    while (i<=FSize) and not All do  // 
    begin
      if not (i in res) then  //     
          begin
            if FDefN[i].a=resNabor[k-1].b then  //    
              begin
                  ResNabor[k]:=FDefN[i];   //    
                  solution (res+[i],k+1,resNabor,all);
              end else
            if (FDefN[i].a<>FDefN[i].b) and (FDefN[i].b=resNabor[k-1].b) then
           //    ,    .
              begin
                Swap(FDefN[i]);
                ResNabor[k]:=FDefN[i];
                solution (res+[i],k+1,resNabor,all);
              end;
          end;
    inc(i);
    end;
  end;
end;


procedure Domino.LangLinie;
var all: boolean;
    i: integer;
begin//. .
  all:=false;//      
  i:=1;
  while (i<=Size) and not all do
  begin
    FResNabor[1]:=FDefN[i];  //  
    solution ([i],2,FresNabor,all);
    if (FDefN[i].a<>FDefN[i].b) and not all then  //  , 
                //       e .
      begin
        swap(FDefN[i]);
        FResNabor[1]:=FDefN[i];
        solution ([i],2,FresNabor,all);
      end;
    inc(i);
  end;
  FMaxK:=FMaxK-1;
end;

function Domino.AddSt (_a,_b: TNum): boolean;
begin    // 
  if FSize=MaxN then result:=false
  else     //  ,  result=false
  begin
    result:=true;    // .
    inc(FSize);
    FDefN[FSize].a:=_a;
    FDefN[FSize].b:=_b;
  end;
end;
end.
