unit UDraw;

interface
uses   Windows, Messages, SysUtils, Variants, Classes, Controls, Forms,
  Dialogs, StdCtrls,Graphics,UDomino,Grids;
const Sz = 30; // 
      rad = 3;   // 
      ot = 5;  //

type
DominoDraw = class (Domino)
private
  FDrG{DrawGrid  . },
  resDrG{DrawGrid   }: TDrawGrid;
  kl: integer;   //    2 DrawGrid

  procedure DrawN (n: byte; R: TRect; C: TCanvas);
public
  constructor Create (ADrG,aResDrG: TDrawGrid);
  function AddSt(_a,_b: TNum): boolean; //
  procedure DrawDef;   // . 
  Procedure DrawRes;   //  
end;


implementation
//  
procedure DominoDraw.DrawN (n: byte; R: TRect; C: TCanvas);

// 
procedure makePoint (x,y: integer);
begin
   C.Ellipse(x-rad, y-rad, x+rad, y+rad)
end;

begin
// 
  C.Brush.Color:=clWhite;
  C.Rectangle(R.Left+1,R.Top+1,R.Left+Sz-1,R.Top+Sz-1);
  C.Brush.Color:=clBlack;
  // 
  if n>1 then
    begin
      makePoint(R.Left+ot,R.Top+ot); //  
      makePoint(R.Left+Sz-ot,R.Top+Sz-ot);//   
    end;
  if n>3 then
    begin
      makePoint(R.Left+Sz-ot,R.Top+ot); // 
      makePoint(R.Left+ot,R.Top+Sz-ot); // 
    end;
  if odd(n) then
    makePoint(R.Left+Sz div 2,R.Top+Sz div 2); //
  if n=6 then
    begin
      makePoint(R.Left+Sz div 2,R.Top+ot); // 
      makePoint(R.Left+Sz div 2,R.Top+Sz-ot)//  
    end;
end;

// . 
procedure DominoDraw.DrawDef;
var i: integer;
begin
for i := 1 to Size do
  begin
  //  
  DrawN(FDefN[i].a,FDrG.CellRect(i-1,0), FDrG.Canvas);
  DrawN(FDefN[i].b,FDrG.CellRect(i-1,1), FDrG.Canvas);
  //  -   :)
  FDrg.Canvas.Pen.Width:=3;
  FDrG.Canvas.MoveTo(FDrG.CellRect(i-1,0).Left+2,FDrG.CellRect(i-1,0).Bottom);
  FDrg.Canvas.LineTo(FDrG.CellRect(i-1,0).Right-2,FDrG.CellRect(i-1,0).Bottom);
  FDrg.Canvas.Pen.Width:=1;
  end;
end;

function DominoDraw.AddSt(_a,_b: TNum): boolean;
begin
  result:=inherited AddSt(_a,_b);//   
  if result then
    begin
      FDrG.ColCount:=FDrG.ColCount+1;//. -   DrawGrid
      DrawDef; // .
    end;
end;


constructor DominoDraw.Create(ADrG,aResDrG: TDrawGrid);
begin
  inherited Create;
  ResDrG:=AResDrG;
  FDrG:=ADrG;
  FDrG.ColCount:=0;
  FDrG.RowCount:=2;
  FMaxK:=0;
end;

// 
procedure DominoDraw.Drawres;
var i: integer;
    R: TRect;
begin
//    -    .
  ResDrG.ColCount:=MaxSize*2;
  kl:=0;
  for i := 1 to MaxSize do
  // -    ,   
  // 
    if MaxNabor[i].a=MaxNabor[i].b then
      begin
         R:=resDrG.CellRect(kl,1);
         R.Top:=R.Top-(sz div 2);
         DrawN(MaxNabor[i].a,R,ResDrg.Canvas);
         R.Top:=R.Top+sz;
         DrawN(MaxNabor[i].a,R,ResDrg.Canvas);
         resDrg.Canvas.Pen.Width:=3;
         resDrG.Canvas.MoveTo(R.Left+2,R.Top);
         resDrg.Canvas.LineTo(R.Right-2,R.Top);
         resDrg.Canvas.Pen.Width:=1;
         kl:=kl+1;

      end
      else // - .
      begin
        DrawN(MaxNabor[i].a,resDrG.CellRect(kl,1),ResDrg.Canvas);
        DrawN(MaxNabor[i].b,resDrG.CellRect(kl+1,1),ResDrg.Canvas);
         resDrg.Canvas.Pen.Width:=3;
         resDrG.Canvas.MoveTo(resDrG.CellRect(kl+1,1).Left,resDrG.CellRect(kl+1,1).Top+2);
         resDrg.Canvas.LineTo(resDrG.CellRect(kl+1,1).Left,resDrG.CellRect(kl+1,1).Bottom-2);
         resDrg.Canvas.Pen.Width:=1;
        kl:=kl+2;
      end;
  ResDrG.ColCount:=kl;
end;

end.
