unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, UDraw, UAdd, Buttons,UDomino;

type
  TForm1 = class(TForm)
    InputGrid: TDrawGrid;
    OutputGrid: TDrawGrid;
    DoBtn: TBitBtn;
    MaxKLbl: TLabel;
    SizeLbl: TLabel;
    AddBtn: TBitBtn;
    RandBtn: TBitBtn;
    procedure InputGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure InputGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DoBtnClick(Sender: TObject);
    procedure OutputGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure RandBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  C,R: integer;
  D: DominoDraw;
implementation

{$R *.dfm}

function CheckD: boolean;
begin
result:=true;

end;

procedure TForm1.AddBtnClick(Sender: TObject);
begin
with NameFrm do
  begin
    if ShowModal=mrOk then
       if D.AddSt(StrToInt(aEdit.Text),StrToInt(bEdit.Text))
        then SizeLbl.Caption:=' : '+IntToStr(D.Size)
        else ShowMessage (' ')
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
D:=DominoDraw.Create(InputGrid,OutPutGrid);
end;

procedure TForm1.DoBtnClick(Sender: TObject);
begin
D.LangLinie;
D.DrawRes;
MaxKLbl.Caption:='  : '+IntToStr(D.MaxSize);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
D:=DominoDraw.Create(InputGrid,OutPutGrid);
randomize;
end;

procedure TForm1.InputGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
D.DrawDef
end;

procedure TForm1.InputGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  C:=ACol;
  R:=ARow;
end;

procedure TForm1.OutputGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
D.DrawRes;
end;

procedure TForm1.RandBtnClick(Sender: TObject);
begin
D.AddSt(random(6),random(6));
  SizeLbl.Caption:=' : '+IntToStr(D.Size)
end;

end.
